#ifndef _BUTTION_INS_H_
#define _BUTTION_INS_H_
#include "base_types.h"
#include "define.h"
#include "movie_clips_def.h"
#include "swf_file_pub.h"
#include <glib.h>

typedef struct btn_ins {
    swf_file_t                  *swf_p;         //  holder
    UI8                         ins_type;
    struct DefineCharacter      *define_p;
    UI16                        depth;
    struct Matrix               matrix;      // ڸʵλñ任
    struct Matrix               ab_matrix;      //  _root λñ任
    struct CxFormWithAlpha      cxform;
    UI16                        clip_depth;
    struct RECT                 boundary;       // ʵĿ.λ twips.
    UI8                         dirty;          // ǷҪȾ
    STRING                      name_p;         // ʵ
    STRING			full_name_p;	// ʵȫ
    gboolean			visible;
    void			*pic_p;		// cache ͼƬָ.
    gboolean			pic_dirty;	// cache ͼƬλ.

    UI8				last_state;
    UI8				current_state;
#define BtnStateDown    0x1<<2			// 1: down 0: up 
#define BtnStateOver    0x1<<1			// 1: over 0: out
#define BtnStateIdle    0x1			// 1: idle 0: no idle
#define BtnStateOverDown	(BtnStateOver|BtnStateDown)
#define BtnStateOutDown		BtnStateDown
#define BtnStateOverUp		BtnStateOver
#define BtnStateOutUp		0

    struct StartSound		*sound_p;
    struct RECT			hit_area;
}
btn_ins_t;

void btn_ins_change(GNode* node_p,struct PlaceObject *cmd_p);
void btn_ins_update_children(GNode* node_p);
void btn_ins_fresh_hit_area(GNode* node_p);
struct ActionRecord* btn_on_event(GNode* node_p);
#endif
