#include "cxform.h"
long
getRed(Cxform *cx,long v) {
    long val;

    val = (long)(cx->RedMultTerm*v+cx->RedAddTerm);
    if (val > 255)
        val = 255;
    else if (val < 0)
        val = 0;
    return val;
}

long
getGreen(Cxform *cx,long v) {
    long val;

    val = (long)(cx->GreenMultTerm*v+cx->GreenAddTerm);
    if (val > 255)
        val = 255;
    else if (val < 0)
        val = 0;
    return val;
}

long
getBlue(Cxform *cx,long v) {
    long val;

    val = (long)(cx->BlueMultTerm*v+cx->BlueAddTerm);
    if (val > 255)
        val = 255;
    else if (val < 0)
        val = 0;
    return val;
}

long
getAlpha(Cxform *cx,long v) {
    long val;

    val = (long)(cx->AlphaMultTerm*v+cx->AlphaAddTerm);
    if (val > 255)
        val = 255;
    else if (val < 0)
        val = 0;
    return val;
}

struct RGBA
    getColor(Cxform *cx,struct RGBA color) {
    Color newColor;

    newColor.Red = getRed(cx,color.Red);
    newColor.Green = getGreen(cx,color.Green);
    newColor.Blue = getBlue(cx,color.Blue);
    newColor.Alpha = getAlpha(cx,color.Alpha);

    return newColor;
}
