#ifndef _FONTS_H_
#define _FONTS_H_

//  FONT
// ===============
// ṹ(DefineFont) а Ƕ  ϵͳ Ϣ.
//
//  ǶϢ Ҫÿַ(Glpyh) (ShapeRecordP).
// ϵͳϢ Ҫÿַ(Glpyh) Unicode (Code),Ӧ
// ϵͳ(FontNameP).
// Ⱦʱʹ Ƕ  ϵͳ,  (TEXT) ָ.
struct KerningRecord {
    struct KerningRecord*       NextP;
    UI16                        FontKerningCode1;
    UI16                        FontKerningCode2;
    SI16                        FontKerningAdjustment;
};

struct GlyphShape {
    struct ShapeRecord*		ShapeRecordP;
    SI16                      	FontAdvance;
    struct RECT                 FontBounds;
    UI16			Code;
};

// XXX  DefineFont,DefineFontInfo, DefineFontInfo2
// DefintFont2
// Font  Character.
struct  DefineFont {
    UI8				CharacterType;//=CharFont
    UI16			CharacterID;
    UI8				FontID;
    UI8				Flags;
#define FontFlagsHasLayout	0x1<<7
#define FontFlagsShiftJIS	0x1<<6
#define FontFlagsSmallText	0x1<<5
#define FontFlagsANSI		0x1<<4
#define FontFlagsWideOffsets	0x1<<3
#define FontFlagsWideCodes	0x1<<2
#define FontFlagsItalic		0x1<<1
#define FontFlagsBold		0x1<<0

#define FontInfoFlagsSmallText	0x1<<5
#define FontInfoFlagsShiftJIS	0x1<<4
#define FontInfoFlagsANSI	0x1<<3
#define FontInfoFlagsItalic	0x1<<2
#define FontInfoFlagsBold	0x1<<1
#define FontInfoFlagsWideCodes	0x1<<0

    UI8				LanguageCode;
    STRING             		FontNameP;		//ڴ
    SI16                        FontAscent;
    SI16                        FontDescent;
    SI16                        FontLeading;
    UI16                        KerningCount;
    struct KerningRecord*       KerningTableP;

    UI16			NumGlyphs;
    struct GlyphShape		GlyphShape[1];
};

#endif
