#ifndef _INSTANCE_H_
#define _INSTANCE_H_
#include "base_types.h"
#include "define.h"
#include "movie_clips_def.h"
#include "swf_file_pub.h"
#include <glib.h>

typedef struct instance {
    swf_file_t			*swf_p;		//  holder
    UI8				ins_type;
    struct DefineCharacter	*define_p;
    UI16                        depth;
    struct Matrix               matrix;		// ڸʵλñ任
    struct Matrix               ab_matrix;	//  _root λñ任
    struct CxFormWithAlpha      cxform;
    UI16                        clip_depth;
    struct RECT			boundary;	// ʵĿ.λ twips.
    UI8				dirty;		// ǷҪȾ
    STRING			name_p;		// ʵ
    STRING			full_name_p;	// ʵȫ
    gboolean			visible;
    void			*pic_p;		// cache ͼƬָ.
    gboolean			pic_dirty;	// cache ͼƬλ.
}
instance_t;

#define INS_MC		1
#define INS_BTN		2
#define INS_STX		3
#define INS_DTX		4
#define INS_MRH		5
#define INS_SHP		6

GNode* ins_new(swf_file_t *swf_p,struct PlaceObject * cmd_p);	// PlaceObject 
void ins_change(GNode* node_p,struct PlaceObject *cmd_p) ;	// PlaceObject Ķ
GNode* ins_name_to_node(GNode* node_p,const char *name_p);		//Ҷ
char* ins_node_to_name(GNode* node_p);
void ins_fresh_boundary(GNode* node_p);				//¼λñ任( _root)
void ins_destory(GNode* node_p);				//ٶӶ

double ins_get_x(GNode* node_p);
double ins_get_y(GNode* node_p);
float ins_get_xscale(GNode* node_p);
float ins_get_yscale(GNode* node_p);
gboolean ins_get_visible(GNode* node_p);
long ins_get_currentframe(GNode* node_p);
long ins_get_totalframe(GNode* node_p);
float ins_get_alpha(GNode* node_p);
long ins_get_width(GNode* node_p);
long ins_get_height(GNode* node_p);
void ins_set_x(GNode* node_p,double value);
void ins_set_y(GNode* node_p,double value);
void ins_set_xscale(GNode* node_p,float value);
void ins_set_yscale(GNode* node_p,float value);
void ins_set_visible(GNode* node_p,gboolean value);
void ins_set_alpha(GNode* node_p,float value);
void ins_set_width(GNode* node_p,long value);
void ins_set_height(GNode* node_p,long value);
#endif
