#ifndef _MOVIE_CLIP_INS_H_
#define _MOVIE_CLIP_INS_H_
#include "base_types.h"
#include "define.h"
#include "movie_clips_def.h"
#include "swf_file_pub.h"
#include <glib.h>
typedef struct mc_ins {
    swf_file_t                  *swf_p;         //  holder
    UI8                         ins_type;
    struct DefineCharacter      *define_p;
    UI16                        depth;
    struct Matrix               matrix;      // ڸʵλñ任
    struct Matrix               ab_matrix;      //  _root λñ任
    struct CxFormWithAlpha      cxform;
    UI16                        clip_depth;
    struct RECT                 boundary;       // ʵĿ.λ twips.
    UI8                         dirty;          // ǷҪȾ
    STRING                      name_p;         // ʵ
    STRING			full_name_p;	// ʵȫ
    gboolean			visible;
    void			*pic_p;		// cache ͼƬָ.
    gboolean			pic_dirty;	// cache ͼƬλ.

    UI16                        next_frame;
    UI16                        last_frame;		// ϴβŵ
    UI8                         state;
#define MC_PLAY     1
#define MC_STOP     2
#define MC_TO_STOP   4	// űΪ STOP ״̬ 

    struct RECT			update_rect;

    struct ActionBlock 		*actions_p;
}
mc_ins_t;

void mc_ins_evolve(GNode* node_p);
void mc_ins_change(GNode* node_p,struct PlaceObject *cmd_p);
void mc_ins_update_children(GNode* node_p);
void mc_ins_prev_frame(GNode* node_p);
void mc_ins_next_frame(GNode* node_p);
void mc_ins_play(GNode* node_p);
void mc_ins_stop(GNode* node_p);
void mc_ins_go_and_play(GNode* node_p,UI16 frame);
void mc_ins_go_and_stop(GNode* node_p,UI16 frame);
void mc_ins_duplicate(GNode* node_p,char* name_p,UI32 depth);
void mc_ins_remove(GNode* node_p) ;
long mc_ins_get_bytes_loaded(GNode* node_p) ;
long mc_ins_get_bytes_total(GNode* node_p) ;
void mc_ins_local_to_global(GNode* node_p,long *x_p, long *y_p) ;
void mc_ins_global_to_local(GNode* node_p,long *x_p, long *y_p) ;
gboolean mc_ins_hit_test(GNode* node_p,long x, long y) ;
int mc_ins_label_find(GNode* node_p,char *label_p);
void mc_ins_attach(GNode* node_p,UI16 c_id, char* name_p,UI32 depth);
#endif
