#ifndef _STATIC_TEXT_H_
#define _STATIC_TEXT_H_
#include "base_types.h"
#include "shape_def.h"
#include "swf_file_pub.h"

// ̬ TEXT
// ===============
// ̬(DefineText) ָӰƬŹ,仯.
struct  GlyphEntry      {
    UI32                 GlyphIndex;
    SI32                 GlyphAdvance;
    struct Matrix	 GlyphMatrix;
    struct DefineShape	 Shape;
};

struct TextRecord       {
    struct TextRecord*	NextP;
    UI8			Flags;
#define TextRecordType		0x1<<7
#define StyleFlagsHasFont	0x1<<3
#define StyleFlagsHasColor	0x1<<2
#define StyleFlagsHasYOffset	0x1<<1
#define StyleFlagsHasXOffset	0x1<<0

    UI16                FontID;
    struct RGBA         TextColor;
    SI16                XOffset;
    SI16                YOffset;
    UI16                TextHeight;
    UI8                 GlyphCount;
    struct GlyphEntry   GlyphEntries[1];
};

//  DefineText, DefineText2
struct DefineText {
    UI8                 CharacterType ; //= CharText;
    UI16		CharacterID;
    struct RECT         TextBounds;
    struct Matrix       TextMatrix;
    UI8                 GlyphBits;
    UI8                 AdvanceBits;
    struct TextRecord*  TextRecordsP;           // textrecord 
};

void stx_to_shape(swf_file_t *swf_p,struct DefineText *Text);
#endif
