#ifndef _XEVENT_PUB_H_
#define _XEVENT_PUB_H_
#include <glib.h>
#include <inttypes.h>
#include "xwin_pub.h"

typedef struct flash_event {
    uint8_t		event_type;
#define EVENT_KEY_PRESS 		1
#define EVENT_KEY_RELEASE 		2
#define EVENT_BUTTON_PRESS 		3
#define EVENT_BUTTON_RELEASE 		4
#define EVENT_MOTION_NOTIFY 		5

    uint8_t		key_value;
    uint16_t		x,y;
}
flash_event_t;

void xwin_event_init(xwin_t *xwin_p);
void xwin_event_get(xwin_t *xwin_p);
#endif
