#include "base_types.h"
#include "config.h"
#include "define.h"
#include "movie_clips_def.h"
#include "swf_file_pub.h"
#include "dynamic_text_def.h"
#include "static_text_def.h"
#include "dynamic_text_ins.h"
#include "font_def.h"
#include <stdlib.h>

extern player_t      *player_p;
char* dvar_get_value(char* name_p) {
    swf_file_t	*swf_p = player_p->_level0_p;
    char	*value_p = NULL;
    char	*p = NULL;

    p = g_ascii_strdown(name_p,-1);
    value_p = g_datalist_get_data(&swf_p->dvar_list_p,p);
    free(p);
    return value_p;
};

void dvar_set_value(char* name_p,char* value_p) {
    swf_file_t	*swf_p = player_p->_level0_p;
    char	*old_value_p = NULL;
    char	*p = NULL;

    p = g_ascii_strdown(name_p,-1);

    old_value_p =  g_datalist_get_data(&swf_p->dvar_list_p,p);
    if (old_value_p) {
        free(old_value_p);
    };
    if (value_p == NULL) {
        value_p = "";
    };
    printf("create var %s value %s \n",p,value_p);
    g_datalist_set_data(&swf_p->dvar_list_p,p,g_strdup(value_p));

    free(p);
};
