#ifndef _RENDER_PUB_H_
#define _RENDER_PUB_H_
#include <glib.h>
#include "instance.h"
#include "player_pub.h"
#include "swf_file_pub.h"
#include "movie_clips_ins.h"
#include "render_pub.h"

typedef struct render {
    player_t		*player_p;

}
render_t;

render_t *render_new(player_t *player_p);
void render_do_render(render_t *render_p);
void render_draw_box(struct RECT *rect_p,gboolean dirty);
void render_draw_node(GNode* node_p,gpointer render_p);
void render_clear_box(render_t *render_p);
void render_destory(render_t *render_p);
#endif
