#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "render_rend.h"
#include "cxform.h"
#include "matrix.h"
#include "rect.h"
#include "instance.h"
#include "base_types.h"
#include "bitmap_def.h"
#include "render_mask.h"
#include <assert.h>

#if WITH_DMALLOC
#include <dmalloc.h>
#endif
extern player_t 	*player_p;
extern first_frame;
extern  struct RECT Bbox;
extern unsigned char SQRT[];
extern unsigned int canvassize;
extern unsigned int gmaskflag;
extern unsigned int gmaskedflag;
extern int save;
extern struct savearea *currentpic;
extern struct RECT idrect;
struct RGB     BackgroundColorCopy;
struct GraphicDevice gd;
#define FULL_AA

#define PRINT 0


typedef unsigned long TYPE;
void maskfunc(GraphicDevice *gd1,long y,long start,long end) {
    struct MaskEntry *currentmaskentry;
    unsigned char *currentmaskpointer;
    currentmaskentry=player_p->_level0_p->mask_stack_p;
    currentmaskpointer=currentmaskentry->maskpointer;

}

int  maskedfunc(GraphicDevice *gd1,TYPE *point) {
    struct MaskEntry *currentmaskentry;
    unsigned char *currentmaskpointer;
    currentmaskentry=player_p->_level0_p->mask_stack_p;
    currentmaskpointer=currentmaskentry->maskpointer;

    switch((((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer))<<29)>>29) {
    case 0:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x01)
            return 1;
        else
            return 0;
        break;

    case 1:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x02)
            return 1;
        else
            return 0;
        break;
    case 2:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x04)
            return 1;
        else
            return 0;
        break;
    case 3:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x08)
            return 1;
        else
            return 0;
        break;
    case 4:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x10)
            return 1;
        else
            return 0;
        break;
    case 5:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x20)
            return 1;
        else
            return 0;
        break;
    case 6:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x40)
            return 1;
        else
            return 0;
        break;
    case 7:

        if(*(currentmaskpointer+(unsigned int)((((unsigned int)((unsigned int)(point)-(unsigned int)(gd1->canvasBuffer)))>>3)))&0x80)
            return 1;
        else
            return 0;
        break;
    }
}
long allocColor16(GraphicDevice *gd1,Color color) {
    // return (color.Red >> 3)<<11 | (color.Green>>2)<<5 | (color.Blue>>3);
    return ((color.Alpha)<<24|(color.Red)<<16 | (color.Green)<<8 |(color.Blue));

}

void
clearCanvas16(GraphicDevice *gd1,int first_frame) {
    TYPE  pixel;
    TYPE *point,*p;
    long                 h, w,n;



    if (!gd1->bgInitialized) {
        return;
    }
    gd1->backgroundColor.Red=player_p->_level0_p->BackgroundColor.Red;
    gd1->backgroundColor.Green=player_p->_level0_p->BackgroundColor.Green;
    gd1->backgroundColor.Blue=player_p->_level0_p->BackgroundColor.Blue;
    if((BackgroundColorCopy.Red!=player_p->_level0_p->BackgroundColor.Red)||(BackgroundColorCopy.Green!=player_p->_level0_p->BackgroundColor.Green)||(BackgroundColorCopy.Blue!=player_p->_level0_p->BackgroundColor.Blue)) {
        BackgroundColorCopy=player_p->_level0_p->BackgroundColor;
        gd1->backgroundColor.Red=player_p->_level0_p->BackgroundColor.Red;
        gd1->backgroundColor.Green=player_p->_level0_p->BackgroundColor.Green;
        gd1->backgroundColor.Blue=player_p->_level0_p->BackgroundColor.Blue;
        gd1->backgroundColor.Alpha=255;
    }
    //    printf("gd->badckgouclor.alpha is %d\n",gd.backgroundColor.Alpha);
    pixel = allocColor16(gd1,gd1->backgroundColor);
    //    printf("pixel is %ld\n",pixel);
    //printf("clip_rect.xmin=%ld clip_rect.ymin=%ld clip_rect.xmax=%ld  clip_rect.ymax=%ld\n",gd->clip_rect.Xmin,gd->clip_rect.Ymin,gd->clip_rect.Xmax,gd->clip_rect.Ymax);
    if(first_frame==0) {
        point = (TYPE *) (gd1->canvasBuffer + gd1->clip_rect.Ymin * (gd1->bpl/2)) + gd1->clip_rect.Xmin;
        point = (TYPE *) ((unsigned char*)(gd1->canvasBuffer) + gd1->clip_rect.Ymin * (gd1->bpl)*2)+gd1->clip_rect.Xmin;
        w = gd1->clip_rect.Xmax - gd1->clip_rect.Xmin;
        h = gd1->clip_rect.Ymax - gd1->clip_rect.Ymin;

#if 0

        asm(
            "up: pushl %%ecx;"		// ѹ h
            "movl %%ebx,%%ecx;"		//  w  ecx
            "cld;"
            "rep;"
            "stosw;"			//  ax д edi  ecx  word 
            "popl %%ecx;"			// ָ h
            "addl %%edx,%%edi;"		// ʼַ
            "loop up;"			// h - 1 ѭ up.
    :
    : "c"(h),"b"(w),"D"(point),"a"(pixel),"d"(gd1->bpl-w*2));
#else

        while (h--) {
            p = point;
            n = w;
            while (n--) {
                *p++ = pixel;
                //printf("to update clip rect\n");
            }

            point = (TYPE *)((char *)point + gd1->bpl*2);
        }
#endif

    } else {

        first_frame=0;
        point = (TYPE *) ((unsigned char*)(gd1->canvasBuffer) + gd1->viewPort.Ymin * (gd1->bpl)*2);
        w = gd1->viewPort.Xmax - gd1->viewPort.Xmin;
        h =  (gd1->viewPort.Ymax - gd1->viewPort.Ymin);
        //printf("w is %ld h is %ld\n",w,h);
        while (h--) {
            p = point;
            n = w;
            while (n--) {

                *p++ = pixel;

                //assert(pixel==-1);
                //*p++ = 0xffffffff;

            }

            point = (TYPE *)((char *)point + gd1->bpl*2);
        }
    }
    gd1->flashDisplay->flash_refresh = 1;

    gd1->flashDisplay->clip_x = gd1->clip_rect.Xmin;
    gd1->flashDisplay->clip_y = gd1->clip_rect.Ymin;
    gd1->flashDisplay->clip_width  = gd1->clip_rect.Xmax-gd1->clip_rect.Xmin;
    gd1->flashDisplay->clip_height = gd1->clip_rect.Ymax-gd1->clip_rect.Ymin;

}

/*#define RED_MASK   0xF800
#define GREEN_MASK 0x07E0
#define BLUE_MASK  0x001F*/

/*#define RED_MASK  0xFF000000
#define GREEN_MASK  0x00FF0000
#define BLUE_MASK  0x0000FF00
#define ALPHA_MASK  0x000000FF*/

#define RED_MASK  0x00FF0000
#define GREEN_MASK  0x0000FF00
#define BLUE_MASK  0x000000FF
#define ALPHA_MASK  0xFF000000



/*void
mix_alpha(unsigned long c1,unsigned long c2,unsigned long p1,unsigned long p2,struct tb *s) {
   long r1,r2,r3,r4,r,rr;
     long g1,g2,g3,g4,g,gg;
      long b1,b2,b3,b4,b,bb;
     long a1,a2;
    
    a1=(p1 & ALPHA_MASK)>>24;
    a2=(p2 & ALPHA_MASK)>>24;
 // printf("a1  is %ld a2 is %ld\n",a1,a1);  
    r1 = (c1 & RED_MASK);
    r2 = (c2 & RED_MASK);
    r3 = (p1 & RED_MASK);
    r4 = (p2 & RED_MASK);
    r = (((r3-r1)*a1 + r1 * 256)>>8 ) & RED_MASK;
   rr = (((r4-r2)*a2 + r2 * 256)>>8 ) & RED_MASK;
    
    g1 = (c1 & GREEN_MASK);
    g2 = (c2 & GREEN_MASK);
    g3 = (p1 & GREEN_MASK);
    g4 = (p2 & GREEN_MASK);
    g = (((g3-g1)*a1 + g1 * 256)>>8) & GREEN_MASK;
    gg = (((g4-g2)*a2 + g2 * 256)>>8) & GREEN_MASK;
    
    b1 = (c1 & BLUE_MASK);
    b2 = (c2 & BLUE_MASK);
    b3 = (p1 & BLUE_MASK);
    b4 = (p2 & BLUE_MASK);
    b = (((b3-b1)*a1 + b1 * 256) >> 8) & BLUE_MASK;
    bb = (((b4-b2)*a2 + b2 * 256) >> 8) & BLUE_MASK;
    
    s->p1=(r|g|b);
    s->p2=(rr|gg|bb);
    return ;
}
*/

void inline mix_line(uint32_t *top, uint32_t *bottom, int length) {
    asm(
        "cld;"
        "xor  %%eax,%%eax;"
        "movd %%eax, %%mm7;"

        // mixed = (alpha*(src-dst))/256 + dst 
        // Ϊֹ alpha*(src-dst) ˷,ʽΪ.
        // mixed = (src-dst)/2*alpha/128 + dst
        // mm0  alpha
        // mm1  dst
        // mm2  src
        // mm7  0
        "up:xor    %%eax,%%eax;"
        "movl    (%%esi),%%eax;"// src -> eax;

        "cmp $0xff000000,%%eax;"
        "jae            fu_gai;"
        "cmp $0x01000000,%%eax;"
        "jb           tou_ming;"

        "movd    (%%edi),%%mm1;"// ͼĵ dst װ mm1
	"movd	   %%eax,%%mm2;"// ͼĵ src װ mm2
	"shr       $24,  %%eax;"
        "movd      %%eax,%%mm0;"
        "punpcklwd %%mm0,%%mm0;"// 00 aa  00 aa 00 aa
        "punpckldq %%mm0,%%mm0;"// 00 aa 00 aa  00 aa 00 aa 00 aa 00 aa

        "punpcklbw %%mm7,%%mm1;"//  dst 8:8:8:8 ĵչΪ 16:16:16:16 ĸʽ.
        "punpcklbw %%mm7,%%mm2;"//  src 8:8:8:8 ĵչΪ 16:16:16:16 ĸʽ.

        "psubsw   %%mm1,%%mm2;"	// ͼɫȥͼɫ (src - dst)->mm2 ;
        "psraw       $1,%%mm2;"	// / 2 -> mm2;
        "pmullw   %%mm0,%%mm2;"	// * alpha -> mm2;
        "psraw       $7,%%mm2;"	// / 128 -> mm2;
        "paddsw   %%mm2,%%mm1;"	// + dst;
        "packuswb %%mm7,%%mm1;"	// ӵĽ  16:16:16:16 ĸʽ pack Ϊ 8:8:8:8 ĸʽ;

        "movd   %%mm1,(%%edi);"

        "add $4,%%esi;"
        "add $4,%%edi;"
        "loop up;"
        "jmp get_out;"

        "fu_gai:;"
        "stosl;"
        "add $4,%%esi;"
        "loop up;"
        "jmp get_out;"

        "tou_ming:;"
        "add $4,%%esi;"
        "add $4,%%edi;"
        "loop up;"

        "get_out:;"
        "emms;"
    :
    : "c"(length),"S"(top),"D"(bottom));

}
void
fillLineAA16(GraphicDevice *gd1,FillStyleDef *f, long y, long start, long end) {

    register long   n;
    long start1,end1,start2,end2;
    TYPE *line,*line1;
    unsigned char *point2,*line2;
    TYPE *point,pixel,*point1,*ppmax,*ppmin;
    unsigned long alpha, start_alpha,end_alpha;
    start1=start;
    end1=end;
    start2=start;
    end2=end;
    start2 >>= FRAC_BITS;
    end2 >>= FRAC_BITS;
    alpha = f->Color.Alpha;
    pixel = f->Color.pixel;
    //printf("idrect aa  xmin is %ld ymin is %ld xmax is %ld ymax is %ld\n",idrect.Xmin,idrect.Ymin,idrect.Xmax,idrect.Ymax);
    //printf("y is %ld start is %ld end is %ld\n",y,start2,end2);
    if(start>end)
        start=end;

    if(save==1&&currentpic&&gmaskflag==0) {
        if(currentpic) {
            ppmax=(unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin+1)*(idrect.Ymax-idrect.Ymin+1);
            ppmin=(unsigned long*)(currentpic->pp);
        }

        /*start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
        end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);

        start >>= FRAC_BITS;
        end >>= FRAC_BITS;*/
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
            return;
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
            return;
        line1=(TYPE *) ((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));



        // printf("x1 is %ld x2 is %ld\n",currentpic->sp[y-idrect.Ymin].x1,currentpic->sp[y-idrect.Ymin].x2);

        /* if(currentpic->fillflag==0)
         {
        //if(start-idrect.Xmin<=currentpic->sp[y-idrect.Ymin].x1)
         currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin-1;
         //if(end-idrect.Xmin>=currentpic->sp[y-idrect.Ymin].x2)
         currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin+1;
        //  printf("x1 is %ld x2 is %ld\n",currentpic->sp[y-idrect.Ymin].x1,currentpic->sp[y-idrect.Ymin].x2);
         }*/
        if (alpha == ALPHA_OPAQUE) {

            start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
            end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);

            start >>= FRAC_BITS;
            end >>= FRAC_BITS;

            point1=&line1[start-idrect.Xmin];

            if (start == end) {

                if((point1<ppmax)&&(point1>ppmin))
                    *point1=(pixel&0x00FFFFFF)|(((start_alpha + end_alpha - 255)<<24)&(0xff000000));
            } else {
                n = end-start;
                if (start_alpha < 255) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((start_alpha<<24)&(0xFF000000));


                    point1++;
                    n--;
                }
                while (n > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1 = pixel;

                    point1++;

                    n--;
                }
                if (end_alpha > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((end_alpha<<24)&(0xFF000000));

                }
            }
        } else {

            start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
            end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);
            start >>= FRAC_BITS;
            end >>= FRAC_BITS;
            point1=&line1[start-idrect.Xmin];
            if (start == end) {
                if((point1<ppmax)&&(point1>ppmin))
                    *point1=(pixel&0x00FFFFFF)|(((((start_alpha + end_alpha - 255) * alpha) >> 8)<<24)&(0xFF000000));

            } else {

                n = end-start;
                if (start_alpha < 255) {

                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((((start_alpha * alpha) >> 8)<<24)&(0xFF000000));
                    point1++;
                    n--;
                }
                while (n > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((alpha<<24)&(0xFF000000));
                    point1++;

                    n--;
                }
                if (end_alpha > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((((end_alpha * alpha) >> 8)<<24)&(0xFF000000));

                }
            }
        }


    } else
        if(gmaskflag) {
            struct MaskEntry *currentmaskentry;
            unsigned char *currentmaskpointer;
            currentmaskentry=player_p->_level0_p->mask_stack_p;
            currentmaskpointer=currentmaskentry->maskpointer;
            line2 = (unsigned char *)currentmaskpointer +(gd1->bpl*y)/2;
            if (alpha == ALPHA_OPAQUE) {

                start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
                end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);

                start >>= FRAC_BITS;
                end >>= FRAC_BITS;

                //point1=&line1[start-idrect.Xmin];
                point2=&line2[start];

                if (start == end) {
                    if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                        *point2=1;

                } else {
                    n = end-start;
                    if (start_alpha < 255) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;


                        point2++;
                        n--;
                    }
                    while (n > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2 = 1;

                        point2++;
                        n--;
                    }
                    if (end_alpha > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;

                    }
                }
            } else {

                start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
                end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);
                start >>= FRAC_BITS;
                end >>= FRAC_BITS;


                point2=&line2[start];
                if (start == end) {
                    if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                        *point2=1;

                } else {
                    n = end-start;
                    if (start_alpha < 255) {

                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;
                        point2++;
                        n--;
                    }
                    while (n > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;

                        point2++;
                        n--;
                    }
                    if (end_alpha > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;

                    }
                }
            }


        }



}

void
fillLineAA161(GraphicDevice *gd1,FillStyleDef *f, long y, long start, long end) {
    register long   n;
    long start1,end1,start2,end2;
    TYPE *line,*line1;
    TYPE *point,pixel,*point1,*ppmax,*ppmin;
    unsigned char *point2,*line2;
    unsigned long alpha, start_alpha,end_alpha;
    start1=start;
    end1=end;
    start2=start;
    end2=end;
    start2 >>= FRAC_BITS;
    end2 >>= FRAC_BITS;
    alpha = f->Color.Alpha;
    pixel = f->Color.pixel;

    if(start>end)
        start=end;

    if(save==1&&currentpic&&gmaskflag==0) {
        if(currentpic) {
            ppmax=(unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin+1)*(idrect.Ymax-idrect.Ymin+1);
            ppmin=(unsigned long*)(currentpic->pp);
        }

        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
            return;
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
            return;
        line1=(TYPE *) ((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));



        // printf("x1 is %ld x2 is %ld\n",currentpic->sp[y-idrect.Ymin].x1,currentpic->sp[y-idrect.Ymin].x2);

        /* if(currentpic->fillflag==0)
         {
        //if(start-idrect.Xmin<=currentpic->sp[y-idrect.Ymin].x1)
         currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin-1;
         //if(end-idrect.Xmin>=currentpic->sp[y-idrect.Ymin].x2)
         currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin+1;
        //  printf("x1 is %ld x2 is %ld\n",currentpic->sp[y-idrect.Ymin].x1,currentpic->sp[y-idrect.Ymin].x2);
         }*/
        if (alpha == ALPHA_OPAQUE) {

            start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
            end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);

            start >>= FRAC_BITS;
            end >>= FRAC_BITS;

            point1=&line1[start-idrect.Xmin];

            if (start == end) {

                if((point1<ppmax)&&(point1>ppmin))
                    *point1=(pixel&0x00FFFFFF)|(((start_alpha + end_alpha - 255)<<24)&(0xff000000));

            } else {
                n = end-start;
                if (start_alpha < 255) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((start_alpha<<24)&(0xFF000000));


                    point1++;
                    n--;
                }
                while (n > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1 = pixel;

                    point1++;
                    n--;
                }
                if (end_alpha > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((end_alpha<<24)&(0xFF000000));

                }
            }
        } else {

            start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
            end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);
            start >>= FRAC_BITS;
            end >>= FRAC_BITS;


            point1=&line1[start-idrect.Xmin];
            if (start == end) {
                if((point1<ppmax)&&(point1>ppmin))
                    *point1=(pixel&0x00FFFFFF)|(((((start_alpha + end_alpha - 255) * alpha) >> 8)<<24)&(0xFF000000));

            } else {
                n = end-start;
                if (start_alpha < 255) {

                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((((start_alpha * alpha) >> 8)<<24)&(0xFF000000));

                    point1++;
                    n--;
                }
                while (n > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((alpha<<24)&(0xFF000000));

                    point1++;
                    n--;
                }
                if (end_alpha > 0) {
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(pixel&0x00FFFFFF)|((((end_alpha * alpha) >> 8)<<24)&(0xFF000000));

                }
            }
        }


    } else
        if(gmaskflag) {
            struct MaskEntry *currentmaskentry;
            unsigned char *currentmaskpointer;
            currentmaskentry=player_p->_level0_p->mask_stack_p;
            currentmaskpointer=currentmaskentry->maskpointer;




            line2 = (unsigned char *)currentmaskpointer +(gd1->bpl*y)/2;


            if (alpha == ALPHA_OPAQUE) {
                start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
                end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);

                start >>= FRAC_BITS;
                end >>= FRAC_BITS;


                //point1=&line1[start-idrect.Xmin];
                point2=&line2[start];

                if (start == end) {
                    if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                        *point2=1;

                } else {
                    n = end-start;
                    if (start_alpha < 255) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;


                        point2++;
                        n--;
                    }
                    while (n > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2 = 1;

                        point2++;
                        n--;
                    }
                    if (end_alpha > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;

                    }
                }
            } else {

                start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
                end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);
                start >>= FRAC_BITS;
                end >>= FRAC_BITS;


                point2=&line2[start];
                if (start == end) {
                    if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                        *point2=1;

                } else {
                    n = end-start;
                    if (start_alpha < 255) {

                        if((((unsigned long)(point1)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point1)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;
                        point2++;
                        n--;
                    }
                    while (n > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;

                        point2++;
                        n--;
                    }
                    if (end_alpha > 0) {
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;

                    }
                }
            }


        }
}

void
fillLineBitmap(GraphicDevice *gd,FillStyleDef *f, long y, long start, long end) {
    static int flag;
    int coun;
    int n;
    long x1,y1,dx,dy;
    Matrix *m;
    long start1,end1;
    struct DefineBitsJPEG *b;
    unsigned char *pixels;
    TYPE *p,*p1,*line1,*ppmax,*ppmin;
    unsigned char *point2,*line2;
    Color *cmap;
    long pixbpl;
    TYPE pixel;
    int offset;
    unsigned char *alpha_table;
    // b=(struct DefineBitsJPEG *)(DictionaryP->dict[f->BitmapId]);
    b=(struct DefineBitsJPEG *)(player_p->_level0_p->dict_p->dict[f->BitmapId]);
    m = &f->BitmapMatrix;
    if (!b)
        return;
    // printf("to fill bitmap    ...............................................\n");
    //   if (clip(gd,&y,&start,&end))
    //      return;
    start1=start;
    end1=end;

    if(save==1&&currentpic&&gmaskflag==0) {
        ppmax=(unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin+1)*(idrect.Ymax-idrect.Ymin+1);
        ppmin=(unsigned long*)(currentpic->pp);
        start /= FRAC;
        end /= FRAC;
        n = end - start;
        //  printf("y is %ld start is %ld end is %ld\n",y,start,end);
        p = (TYPE *) (gd->canvasBuffer + gd->bpl*y + start * 2);
        x1 = (long) (m->ScaleX * start + m->RotateSkew0 * y + m->TranslateX);
        y1 = (long) (m->RotateSkew1 * start + m->ScaleY * y + m->TranslateY);

        dx = (long) (m->ScaleX);
        dy = (long) (m->RotateSkew1);

        pixels = b->PixelsP;
        pixbpl = b->Bpl;
        cmap = f->cmap;
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
            return;
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
            return;

        line1=(TYPE *)(currentpic->pp+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));
        /* if(currentpic->fillflag==0)
           {
           printf("to fillflag===0\n");
           currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin+1;
           currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin-1;
           }*/



        p1=&line1[start-idrect.Xmin];
        if (b->Alpha_bufP == NULL) {
            while (n) {
                if (x1 >= 0 && y1 >= 0 &&
                        (x1 >> 16) < b->Width && (y1 >> 16) < b->Height) {

                    pixel = cmap[pixels[(y1 >> 16) * pixbpl + (x1 >> 16)]].pixel;
                    if((p1<ppmax)&&(p1>ppmin))
                        *p1=(pixel&0x00FFFFFF)|((0xFF000000));
                    //*p1=pixel|((alpha)&(0x000000ff));
                    //*p1 = pixel;
                    //*p1=*p;
                }

                x1 += dx;
                y1 += dy;

                p1++;
                n--;
            }
        } else if (f->alpha_table) {
            alpha_table = f->alpha_table;
            while (n) {
                if (x1 >= 0 && y1 >= 0 &&
                        (x1 >> 16) < b->Width && (y1 >> 16) < b->Height) {

                    offset = (y1 >> 16) * pixbpl + (x1 >> 16);
                    pixel = cmap[pixels[offset]].pixel;
                    if((p1<ppmax)&&(p1>ppmin))
                        *p1=(pixel&0x00FFFFFF)|((alpha_table[b->Alpha_bufP[offset]]<<24)&(0xFF000000));
                    // *p1 = mix_alpha(*p, pixel, alpha_table[b->Alpha_bufP[offset]]);
                    //*p1=*p;
                }
                x1 += dx;
                y1 += dy;
                //p++;
                p1++;
                n--;
            }
        } else {
            while (n) {
                if (x1 >= 0 && y1 >= 0 &&
                        (x1 >> 16) < b->Width && (y1 >> 16) < b->Height) {

                    offset = (y1 >> 16) * pixbpl + (x1 >> 16);
                    pixel = cmap[pixels[offset]].pixel;
                    if((p1<ppmax)&&(p1>ppmin))
                        *p1=(pixel&0x00FFFFFF)|((b->Alpha_bufP[offset]<<24)&(0xFF000000));
                    //*p1 = mix_alpha(*p, pixel, b->Alpha_bufP[offset]);
                    //*p1=*p;
                }
                x1 += dx;
                y1 += dy;
                // p++;
                p1++;
                n--;
            }
        }
    }
    else
        if(gmaskflag==1) {
            {
                struct MaskEntry *currentmaskentry;
                unsigned char *currentmaskpointer;
                currentmaskentry=player_p->_level0_p->mask_stack_p;
                currentmaskpointer=currentmaskentry->maskpointer;
                start /= FRAC;
                end /= FRAC;
                n = end - start;
                //  printf("y is %ld start is %ld end is %ld\n",y,start,end);
                p = (TYPE *) (gd->canvasBuffer + gd->bpl*y + start * 2);
                x1 = (long) (m->ScaleX * start + m->RotateSkew0 * y + m->TranslateX);
                y1 = (long) (m->RotateSkew1 * start + m->ScaleY * y + m->TranslateY);

                dx = (long) (m->ScaleX);
                dy = (long) (m->RotateSkew1);

                pixels = b->PixelsP;
                pixbpl = b->Bpl;
                cmap = f->cmap;
                /* if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
                return;
                if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
                return;*/

                // line1=(TYPE *)(currentpic->pp+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));
                line2 = (unsigned char *)currentmaskpointer +(gd->bpl*y)/2;
                /* if(currentpic->fillflag==0)
                   {
                   printf("to fillflag===0\n");
                   currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin+1;
                   currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin-1;
                   }*/

                point2=&line2[start];

                //   p1=&line1[start-idrect.Xmin];
                if (b->Alpha_bufP == NULL) {
                    while (n) {
                        if (x1 >= 0 && y1 >= 0 &&
                                (x1 >> 16) < b->Width && (y1 >> 16) < b->Height) {

                            pixel = cmap[pixels[(y1 >> 16) * pixbpl + (x1 >> 16)]].pixel;

                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //*p1=pixel|((alpha)&(0x000000ff));
                            //*p1 = pixel;
                            //*p1=*p;
                        }

                        x1 += dx;
                        y1 += dy;

                        point2++;
                        n--;
                    }
                } else if (f->alpha_table) {
                    alpha_table = f->alpha_table;
                    while (n) {
                        if (x1 >= 0 && y1 >= 0 &&
                                (x1 >> 16) < b->Width && (y1 >> 16) < b->Height) {

                            offset = (y1 >> 16) * pixbpl + (x1 >> 16);
                            pixel = cmap[pixels[offset]].pixel;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            // *p1 = mix_alpha(*p, pixel, alpha_table[b->Alpha_bufP[offset]]);
                            //*p1=*p;
                        }
                        x1 += dx;
                        y1 += dy;
                        //p++;
                        point2++;
                        n--;
                    }
                } else {
                    while (n) {
                        if (x1 >= 0 && y1 >= 0 &&
                                (x1 >> 16) < b->Width && (y1 >> 16) < b->Height) {
                            offset = (y1 >> 16) * pixbpl + (x1 >> 16);
                            pixel = cmap[pixels[offset]].pixel;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //*p1 = mix_alpha(*p, pixel, b->Alpha_bufP[offset]);
                            //*p1=*p;
                        }
                        x1 += dx;
                        y1 += dy;
                        // p++;
                        *point2++;
                        n--;
                    }
                }
            }
        }

}



void
fillLineLG16(GraphicDevice *gd,struct Gradient *grad, long y, long start, long end) {
    long dr,r,v,r2;
    register long n;
    TYPE *line,*line1,*ppmax,*ppmin;
    TYPE *point,*point1;
    unsigned char *point2,*line2;
    Color *cp,*ramp;
    Matrix *m = &grad->imat;
    unsigned int start_alpha,end_alpha;
    struct grend  *lgr;
    long start1,end1;
    //lgr=gd->gradientrend;
    //if(end<start)end=start;
    if(start>end)
        start=end;
    start1=start;
    end1=end;


    //printf("to filllg ..........................................................\n");
    if(save==1&&currentpic&&gmaskflag==0) {
        ppmax=(unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin+1)*(idrect.Ymax-idrect.Ymin+1);
        ppmin=(unsigned long*)(currentpic->pp);
        start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
        end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);
        //printf("start_alpha is %d end_alpha is %d\n",start_alpha,end_alpha);
        start /= FRAC;
        end /= FRAC;

        n = end-start;
        //printf("n is %ld \n",n);
        r = (long) (m->ScaleX * start + m->RotateSkew0 * y + m->TranslateX);
        //printf("r is %ld \n",r);
        dr = (long) (m->ScaleX);
        //printf("dr is %ld \n",dr);
        ramp = grad->g_ramp;

        line = (TYPE *)(gd->canvasBuffer + gd->bpl*y);
        point = &line[start];
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
            return;
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
            return;
        line1=(TYPE *)(currentpic->pp+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));
        /* if(currentpic->fillflag==0)
         {
         currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin;
         currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin;
         }*/



        point1=&line1[start-idrect.Xmin];

        r2 = r + n * dr;
        if ( ((r | r2) & ~255) == 0 ) {

            if (!grad->g_has_alpha) {
#ifdef FULL_AA
                if (start_alpha < 255) {
                    v = r>>16;
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[v].pixel)&0x00FFFFFF)|(((start_alpha)<<24)&(0xFF000000));
                    // *point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, start_alpha);
                    //*point1=*point;

                    point1++;
                    r += dr;
                    n--;
                }
#endif /* FULL_AA */

                while (n>0) {
                    v = r>>16;
                    //*point1 = (TYPE)ramp[v].pixel;
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[v].pixel)&0x00FFFFFF)|((0xFF000000));
                    //*point1=*point;

                    point1++;
                    r += dr;
                    n--;
                }
#ifdef FULL_AA
                if (end_alpha > 0) {
                    v = r>>16;
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[v].pixel)&0x00FFFFFF)|(((end_alpha)<<24)&(0xFF000000));
                    //*point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, end_alpha);
                    //*point1=*point;
                }
#endif /* FULL_AA */

            } else {
                while (n--) {
                    v = r>>16;
                    cp = &ramp[v];
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=((cp->pixel)&0x00FFFFFF)|(((cp->Alpha)<<24)&(0xFF000000));
                    //*point1 = mix_alpha(*point, cp->pixel, cp->Alpha);
                    //*point1=*point;

                    point1++;
                    r += dr;
                }
            }
        } else {
            if (!grad->g_has_alpha) {//printf("to fill lineaa ...........................................................................................................................\n");
#ifdef FULL_AA
                if (start_alpha < 255)
                {
                    v = r>>16;
                    if (v < 0)
                        v = 0;
                    else if (v > 255)
                        v = 255;
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[v].pixel)&0x00FFFFFF)|(((start_alpha)<<24)&(0xFF000000));
                    // *point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, start_alpha);
                    //*point1=*point;

                    point1++;
                    r += dr;
                    n--;
                }
#endif /* FULL_AA */
                while (n>0) {
                    v = r>>16;
                    if (v < 0)
                        v = 0;
                    else if (v > 255)
                        v = 255;
                    if((point1<ppmax)&&(point1>ppmin)) {
                        *point1 = (TYPE)ramp[v].pixel;

                        *point1=(((TYPE)ramp[v].pixel)&0x00FFFFFF)|((0xFF000000));
                    }
                    //*point1=*point;

                    point1++;
                    r += dr;
                    n--;
                }
#ifdef FULL_AA
                if (end_alpha > 0) {
                    v = r>>16;
                    if (v < 0)
                        v = 0;
                    else if (v > 255)
                        v = 255;
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[v].pixel)&0x00FFFFFF)|(((end_alpha)<<24)&(0xFF000000));
                    //*point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, end_alpha);
                    //*point1=*point;
                }
#endif /* FULL_AA */

            } else {
                while (n--) {
                    v = r>>16;
                    if (v < 0)
                        v = 0;
                    else if (v > 255)
                        v = 255;
                    cp = &ramp[v];
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=((cp->pixel)&0x00FFFFFF)|(((cp->Alpha)<<24)&(0xFF000000));
                    // *point1 = mix_alpha(*point, cp->pixel, cp->Alpha);
                    //*point1=*point;

                    point1++;
                    r += dr;
                }
            }
        }

    } else
        if(gmaskflag) {

            {
                struct MaskEntry *currentmaskentry;
                unsigned char *currentmaskpointer;
                currentmaskentry=player_p->_level0_p->mask_stack_p;
                currentmaskpointer=currentmaskentry->maskpointer;
                start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
                end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);
                //printf("start_alpha is %d end_alpha is %d\n",start_alpha,end_alpha);
                start /= FRAC;
                end /= FRAC;

                n = end-start;
                //printf("n is %ld \n",n);
                r = (long) (m->ScaleX * start + m->RotateSkew0 * y + m->TranslateX);
                //printf("r is %ld \n",r);
                dr = (long) (m->ScaleX);
                //printf("dr is %ld \n",dr);
                ramp = grad->g_ramp;

                line = (TYPE *)(gd->canvasBuffer + gd->bpl*y);

                point = &line[start];
                /* if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
                return;
                if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
                return;*/
                //line1=(TYPE *)(currentpic->pp+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));
                line2 = (unsigned char *)currentmaskpointer +(gd->bpl*y)/2;
                /* if(currentpic->fillflag==0)
                 {
                 currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin;
                 currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin;
                 }*/



                point2=&line2[start];

                r2 = r + n * dr;
                if ( ((r | r2) & ~255) == 0 ) {

                    if (!grad->g_has_alpha) {
#ifdef FULL_AA
                        if (start_alpha < 255) {
                            v = r>>16;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            // *point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, start_alpha);
                            //*point1=*point;

                            point2++;
                            r += dr;
                            n--;
                        }
#endif /* FULL_AA */

                        while (n>0) {
                            v = r>>16;
                            //*point1 = (TYPE)ramp[v].pixel;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //*point1=*point;

                            point2++;
                            r += dr;
                            n--;
                        }
#ifdef FULL_AA
                        if (end_alpha > 0) {
                            v = r>>16;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //*point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, end_alpha);
                            //*point1=*point;
                        }
#endif /* FULL_AA */

                    } else {
                        while (n--) {
                            v = r>>16;
                            cp = &ramp[v];
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //*point1 = mix_alpha(*point, cp->pixel, cp->Alpha);
                            //*point1=*point;

                            point2++;
                            r += dr;
                        }
                    }
                } else {//printf("in lg\n");
                    if (!grad->g_has_alpha) {
#ifdef FULL_AA
                        if (start_alpha < 255) {
                            v = r>>16;
                            if (v < 0)
                                v = 0;
                            else if (v > 255)
                                v = 255;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            // *point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, start_alpha);
                            //*point1=*point;

                            point2++;
                            r += dr;
                            n--;
                        }
#endif /* FULL_AA */
                        while (n>0) {
                            v = r>>16;
                            if (v < 0)
                                v = 0;
                            else if (v > 255)
                                v = 255;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2 =1;

                            //*point1=*point;

                            point2++;
                            r += dr;
                            n--;
                        }
#ifdef FULL_AA
                        if (end_alpha > 0) {
                            v = r>>16;
                            if (v < 0)
                                v = 0;
                            else if (v > 255)
                                v = 255;
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //*point1 = mix_alpha(*point, (TYPE)ramp[v].pixel, end_alpha);
                            //*point1=*point;
                        }
#endif /* FULL_AA */

                    } else {
                        while (n--) {
                            v = r>>16;
                            if (v < 0)
                                v = 0;
                            else if (v > 255)
                                v = 255;
                            cp = &ramp[v];
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            // *point1 = mix_alpha(*point, cp->pixel, cp->Alpha);
                            //*point1=*point;

                            point2++;
                            r += dr;
                        }
                    }
                }

            }
        }

}



void
fillLineRG16(GraphicDevice *gd,struct Gradient *grad, long y, long start, long end) {
    //printf("to rg \n");
    long X,dx,r,Y,dy;
    long dist2;
    register long   n;
    Color *cp,*ramp;
    TYPE *line,*line1,*ppmax,*ppmin;
    TYPE *point,*point1;
    unsigned char *point2,*line2;
    Matrix *m = &grad->imat;
    unsigned int start_alpha,end_alpha;
    long start1,end1;
    start1=start;
    end1=end;

    //printf("to filllinerg\n");
    if(save==1&&currentpic&&gmaskflag==0) {
        ppmax=(unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin+1)*(idrect.Ymax-idrect.Ymin+1);
        ppmin=(unsigned long*)(currentpic->pp);
        start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
        end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);

        start /= FRAC;
        end /= FRAC;

        n = end-start;

        X = (long) (m->ScaleX * start + m->RotateSkew0 * y + m->TranslateX);
        Y = (long) (m->RotateSkew1 * start + m->ScaleY * y + m->TranslateY);
        dx = (long) (m->ScaleX);
        dy = (long) (m->RotateSkew1);

        ramp = grad->g_ramp;

        line = (TYPE *)(gd->canvasBuffer + gd->bpl*y);
        point = &line[start];

        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
            return;
        if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
            return;
        line1=(TYPE *)(currentpic->pp+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));
        /* if(currentpic->fillflag==0)
         {
         currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin;
         currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin;
         
         }*/



        point1=&line1[start-idrect.Xmin];
        if (!grad->g_has_alpha) {
#ifdef FULL_AA
            if (start == end) {
                dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                if ((unsigned long)dist2 >= 65536) {
                    r = 255;
                } else {
                    r = SQRT[dist2];
                }
                if((point1<ppmax)&&(point1>ppmin))
                    *point1=(((TYPE)ramp[r].pixel)&0x00FFFFFF)|(((start_alpha + end_alpha - 255)<<24)&(0xFF000000));
                //  *point1 = mix_alpha(*point, (TYPE)ramp[r].pixel, start_alpha + end_alpha - 255);
                // *point1=*point;
            } else {
                if (start_alpha < 255) {
                    dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                    if ((unsigned long)dist2 >= 65536) {
                        r = 255;
                    } else {
                        r = SQRT[dist2];
                    }
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[r].pixel)&0x00FFFFFF)|(((start_alpha)<<24)&(0xFF000000));
                    // *point1 = mix_alpha(*point, (TYPE)ramp[r].pixel, start_alpha);

                    //*point1=*point;
                    //point++;
                    point1++;
                    X += dx;
                    Y += dy;
                    n--;
                }
#endif /* FULL_AA */
                while (n>0) {
                    dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                    if ((unsigned long)dist2 >= 65536) {
                        r = 255;
                    } else {
                        r= SQRT[dist2];
                    }
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[r].pixel)&0x00FFFFFF)|((0xFF000000));
                    //*point1 = (TYPE)ramp[r].pixel;
                    //*point1=*point;
                    //point++;
                    point1++;
                    X += dx;
                    Y += dy;
                    n--;
                }
#ifdef FULL_AA
                if (end_alpha > 0) {
                    dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                    if ((unsigned long)dist2 >= 65536) {
                        r = 255;
                    } else {
                        r= SQRT[dist2];
                    }
                    if((point1<ppmax)&&(point1>ppmin))
                        *point1=(((TYPE)ramp[r].pixel)&0x00FFFFFF)|(((end_alpha)<<24)&(0xFF000000));
                    //  *point1 = mix_alpha(*point, (TYPE)ramp[r].pixel, end_alpha);
                    //*point1=*point;
                }
            }
#endif /* FULL_AA */

        } else {
            while (n--) {
                dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                if ((unsigned long)dist2 >= 65536) {
                    r = 255;
                } else {
                    r= SQRT[dist2];
                }
                cp = &ramp[r];
                if((point1<ppmax)&&(point1>ppmin))
                    *point1=((cp->pixel)&0x00FFFFFF)|(((cp->Alpha)<<24)&(0xFF000000));
                //  *point1 = mix_alpha(*point, cp->pixel, cp->Alpha);
                //*point1=*point;
                //point++;
                point1++;
                X += dx;
                Y += dy;
            }
        }

        // else

    } else
        if(gmaskflag) {
            {
                struct MaskEntry *currentmaskentry;
                unsigned char *currentmaskpointer;
                currentmaskentry=player_p->_level0_p->mask_stack_p;
                currentmaskpointer=currentmaskentry->maskpointer;
                start_alpha = 255 - ((start & (FRAC-1)) << (8-FRAC_BITS));
                end_alpha = (end & (FRAC-1)) << (8-FRAC_BITS);

                start /= FRAC;
                end /= FRAC;

                n = end-start;

                X = (long) (m->ScaleX * start + m->RotateSkew0 * y + m->TranslateX);
                Y = (long) (m->RotateSkew1 * start + m->ScaleY * y + m->TranslateY);
                dx = (long) (m->ScaleX);
                dy = (long) (m->RotateSkew1);

                ramp = grad->g_ramp;

                line = (TYPE *)(gd->canvasBuffer + gd->bpl*y);
                point = &line[start];

                /* if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))>ppmax)
                return;
                if(((unsigned long*)(currentpic->pp)+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin))<ppmin)
                return;
                 line1=(TYPE *)(currentpic->pp+(idrect.Xmax-idrect.Xmin)*(y-idrect.Ymin));*/
                line2 = (unsigned char *)currentmaskpointer +(gd->bpl*y)/2;
                /* if(currentpic->fillflag==0)
                 {
                 currentpic->sp[y-idrect.Ymin].x1=start-idrect.Xmin;
                 currentpic->sp[y-idrect.Ymin].x2=end-idrect.Xmin;
                 
                 }*/



                point2=&line2[start];
                if (!grad->g_has_alpha) {
#ifdef FULL_AA
                    if (start == end) {
                        dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                        if ((unsigned long)dist2 >= 65536) {
                            r = 255;
                        } else {
                            r = SQRT[dist2];
                        }
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;
                        //  *point1 = mix_alpha(*point, (TYPE)ramp[r].pixel, start_alpha + end_alpha - 255);
                        // *point1=*point;
                    } else {
                        if (start_alpha < 255) {
                            dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                            if ((unsigned long)dist2 >= 65536) {
                                r = 255;
                            } else {
                                r = SQRT[dist2];
                            }
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            // *point1 = mix_alpha(*point, (TYPE)ramp[r].pixel, start_alpha);

                            //*point1=*point;
                            //point++;
                            point2++;
                            X += dx;
                            Y += dy;
                            n--;
                        }
#endif /* FULL_AA */
                        while (n>0) {
                            dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                            if ((unsigned long)dist2 >= 65536) {
                                r = 255;
                            } else {
                                r= SQRT[dist2];
                            }
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //*point1 = (TYPE)ramp[r].pixel;
                            //*point1=*point;
                            //point++;
                            point2++;
                            X += dx;
                            Y += dy;
                            n--;
                        }
#ifdef FULL_AA
                        if (end_alpha > 0) {
                            dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                            if ((unsigned long)dist2 >= 65536) {
                                r = 255;
                            } else {
                                r= SQRT[dist2];
                            }
                            if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                                *point2=1;
                            //  *point1 = mix_alpha(*point, (TYPE)ramp[r].pixel, end_alpha);
                            //*point1=*point;
                        }
                    }
#endif /* FULL_AA */

                } else {
                    while (n--) {
                        dist2 = ((X>>16)*(X>>16))+((Y>>16)*(Y>>16));
                        if ((unsigned long)dist2 >= 65536) {
                            r = 255;
                        } else {
                            r= SQRT[dist2];
                        }
                        cp = &ramp[r];
                        if((((unsigned long)(point2)-(unsigned long)(currentmaskpointer))>0)&&(((unsigned long)(point2)-(unsigned long)(currentmaskpointer))<canvassize))
                            *point2=1;
                        //  *point1 = mix_alpha(*point, cp->pixel, cp->Alpha);
                        //*point1=*point;
                        //point++;
                        point2++;
                        X += dx;
                        Y += dy;
                    }
                }



            }
        }

}

void RenderPrepare(GraphicDevice *gd1,FlashDisplay  *fd) {

    gd1->flashDisplay = fd;
    gd1->bgInitialized = 0;

    // Reset flash refresh flag
    fd->flash_refresh = 0;

    /* 16 bits, RGB565 */
    gd1->redMask = 0xF800;
    gd1->greenMask = 0x07E0;
    gd1->blueMask = 0x001F;

    /* should be the actual window size */
    gd1->targetWidth = fd->width;
    gd1->targetHeight = fd->height;
    gd1->bpl = fd->bpl;
    canvassize=(fd->height*fd->bpl)/2;
#if PRINT
    //printf("Target Width  = %d\n", targetWidth);
    //printf("Target Height = %d\n", targetHeight);
#endif

    gd1->zoom = FRAC;
    gd1->movieWidth = gd1->targetWidth;
    gd1->movieHeight = gd1->targetHeight;
    gd1->viewPort.Xmin = 0;
    gd1->viewPort.Xmax = gd1->targetWidth-1;
    gd1->viewPort.Ymin = 0;
    gd1->viewPort.Ymax = gd1->targetHeight-1;

    gd1->canvasBuffer = (unsigned char *) (fd->pixels);

    gd1->adjust = (Matrix *)malloc(sizeof(Matrix));
    MatrixPrepare(gd1->adjust);
    gd1->foregroundColor.Red = 0;
    gd1->foregroundColor.Green = 0;
    gd1->foregroundColor.Blue = 0;
    gd1->foregroundColor.Alpha = ALPHA_OPAQUE;

    gd1->backgroundColor.Red = 255;
    gd1->backgroundColor.Green = 255;
    gd1->backgroundColor.Blue = 255;
    gd1->backgroundColor.Alpha = ALPHA_OPAQUE;

    gd1->showMore = 0;

    setClipping(gd1,0);	// Reset
    setClipping(gd1,1);

    /* polygon rasterizer : handle memory errors ! */

    gd1->thisheight = gd1->targetHeight;
    // gd1->thissegs = (Segment **)malloc(gd1->thisheight * sizeof(Segment *));

    gd1->thissegs1 = (Segment **)malloc(16000 * sizeof(Segment *));

    gd1->thissegs=&(gd1->thissegs1[8000]);
    // memset(gd1->thissegs, 0, gd1->thisheight * sizeof(Segment *));
    memset(gd1->thissegs1, 0, 16000 * sizeof(Segment *));
    gd1->thisymin = 8000;//gd1->thisheight;
    gd1->thisymax = -8000;
    gd1->scan_line_func=NULL;
    gd1->seg_pool = (Segment *)malloc(NB_SEGMENT_MAX * sizeof(Segment));
    gd1->seg_pool_cur = gd1->seg_pool;
    //other
    /*gd1->cmap=NULL;
    gd1->alpha_table=NULL;
           gd1->gradientrend=NULL;
    gd1->bitmaprend=NULL;*/
    BackgroundColorCopy.Red=1;
    BackgroundColorCopy.Green=1;
    BackgroundColorCopy.Blue=1;
}

Color *
getColormap(GraphicDevice *gd1,Color *old, long n, Cxform *cxform) {
    long  i=0;

    Color *newCmp;

    newCmp =(Color *)malloc(n*sizeof(Color));
    if (newCmp == NULL)
        return NULL;

    if (cxform) {
        for( i = 0; i < n; i++) {
            newCmp[i] = getColor(cxform,old[i]);
            newCmp[i].pixel = allocColor16(gd1,newCmp[i]);
        }
    } else {
        //printf("cxform is null\n");
        for( i = 0; i < n; i++) {
            newCmp[i] = old[i];
            newCmp[i].pixel = allocColor16(gd1,old[i]);
        }
    }
    return newCmp;
}

long
getHeight(GraphicDevice *gd1) {
    return gd1->targetHeight;
}

long
getWidth(GraphicDevice *gd1) {
    return gd1->targetWidth;
}

Color
getForegroundColor(GraphicDevice *gd1) {
    return gd1->foregroundColor;
}

void
setForegroundColor(GraphicDevice *gd1,Color color) {
    gd1->foregroundColor = color;
}

Color
getBackgroundColor(GraphicDevice *gd1) {
    gd1->backgroundColor.Red=BackgroundColor.Red;
    gd1->backgroundColor.Green=BackgroundColor.Green;
    gd1->backgroundColor.Blue=BackgroundColor.Blue;
    return gd1->backgroundColor;
}

int
setBackgroundColor( struct GraphicDevice *gd1,struct RGBA color) {
    if (gd1->bgInitialized == 0) {
        gd1->backgroundColor = color;
        clearCanvas16(gd1,1);
        gd1->bgInitialized = 1;
        return 1;
    }
    return 0;
}


void
setMovieDimension(GraphicDevice *gd1,long width, long height) {
    float xAdjust, yAdjust;

    gd1->movieWidth = width;
    gd1->movieHeight = height;
    MatrixPrepare(gd1->adjust);
    xAdjust = (float)(gd1->targetWidth)*(gd1->zoom)/(float)width;
    yAdjust = (float)(gd1->targetHeight)*(gd1->zoom)/(float)height;
    //printf("xadjust is %f yadjust is %f \n",xAdjust ,yAdjust);
    if (xAdjust < yAdjust) {
        gd1->adjust->ScaleX = xAdjust;
        gd1->adjust->ScaleY = xAdjust;
        gd1->adjust->TranslateY = ((gd1->targetHeight*gd1->zoom) - (long)(height * xAdjust))/2;
        gd1->viewPort.Ymin = gd1->adjust->TranslateY/gd1->zoom;
        gd1->viewPort.Ymax = gd1->targetHeight-gd1->viewPort.Ymin-1;
    } else {
        gd1->adjust->ScaleX = yAdjust;
        gd1->adjust->ScaleY = yAdjust;
        gd1->adjust->TranslateX = ((gd1->targetWidth*gd1->zoom) - (long)(width * yAdjust))/2;
        gd1->viewPort.Xmin = gd1->adjust->TranslateX/gd1->zoom;
        gd1->viewPort.Xmax = gd1->targetWidth-gd1->viewPort.Xmin-1;
    }

    if (gd1->viewPort.Xmin < 0)
        gd1->viewPort.Xmin = 0;
    if (gd1->viewPort.Ymin < 0)
        gd1->viewPort.Ymin = 0;
    if (gd1->viewPort.Xmax >= gd1->targetWidth)
        gd1->viewPort.Xmax = gd1->targetWidth-1;
    if (gd1->viewPort.Ymax >= gd1->targetHeight)
        gd1->viewPort.Ymax = gd1->targetHeight-1;
    //printf("scalexset is %f,scaley is %f,rotateskew0 is %f,rotateskew1 is %f,translatex is %ld,translatey is %ld,\n",gd1->adjust->ScaleX,gd1->adjust->ScaleY,gd1->adjust->RotateSkew0,gd1->adjust->RotateSkew1,gd1->adjust->TranslateX,gd1->adjust->TranslateY);
}

void
setMovieZoom(GraphicDevice *gd1,int z) {
    z *= FRAC;
    if (z <= 0 || z > 100)
        return;
    gd1->zoom = z;
    setMovieDimension(gd1,gd1->movieWidth,gd1->movieHeight);
}

void
setMovieOffset(GraphicDevice *gd1,long x, long y) {
    gd1->adjust->TranslateX = -(gd1->zoom)*x;
    gd1->adjust->TranslateY = -(gd1->zoom)*y;
}

long
clip(GraphicDevice *gd1,long *y, long *start, long *end) {
    long xmin,xend;

    if (*y < gd1->clip_rect.Ymin ||
            *y >= gd1->clip_rect.Ymax)
        return 1;
    if (end <= start)
        return 1;
    xmin = gd1->clip_rect.Xmin * FRAC;
    xend = gd1->clip_rect.Xmax * FRAC;

    if (*end <= xmin || *start >= xend)
        return 1;

    if (*start < xmin)
        *start = xmin;
    if (*end > xend)
        *end = xend;

    return 0;
}

/* polygon rasteriser */

Segment *
allocSeg(GraphicDevice *gd1) {
    Segment *seg;
    //printf("nbsegment is  %ld\n",gd1->seg_pool_cur - gd1->seg_pool);
    if ( (gd1->seg_pool_cur - gd1->seg_pool) >= NB_SEGMENT_MAX )
        return NULL;
    seg = gd1->seg_pool_cur++;

    return seg;
}

void
addSegment(GraphicDevice *gd,long x1, long y1, long x2, long y2,
           FillStyleDef *f0,
           FillStyleDef *f1,
           int aa) {


    Segment *seg,**segs;
    long dX, X, Y, ymin, ymax, tmp;
    FillStyleDef *ff;
    //printf("in addsegment\n");

    if ( y1 == y2 ) {
        return;
    }

    if (y1 < y2) {
        ymin = y1;
        ymax = y2;
        ff = f0;
        f0 = f1;
        f1 = ff;
    } else {
        ymin = y2;
        ymax = y1;
        tmp = x1;
        x1 = x2;
        x2 = tmp;
    }

    // if (ymax>>FRAC_BITS < gd->clip_rect.Ymin) {
    //     return;
    // }
    //if (ymin>>FRAC_BITS > gd->clip_rect.Ymax) {
    //   return;
    // }

    X = x1 << SEGFRAC;
    dX = ((x2 - x1)<<SEGFRAC)/(ymax-ymin);

    // if (ymin < 0) {
    //    X += dX * (-ymin);
    //   ymin = 0;
    // }

    Y = (ymin + (FRAC-1)) & ~(FRAC-1);
    if (Y > ymax) {
        //printf("Elimine @ y = %d   ymin = %d, ymax = %d\n", Y, ymin, seg->ymax);
        return;
    }
    X += dX * (Y-ymin);

    Y >>= FRAC_BITS;
    //  if (Y >= gd->clip_rect.Ymax) {
    //    return;
    // }

    seg = allocSeg(gd);

    if (seg == NULL) {
        return;
    }

    seg->next = 0;
    seg->nextValid = 0;
    seg->aa = aa;
    seg->ymax = ymax;
    seg->x1 = x1;
    seg->x2 = x2;
    seg->X = X;
    seg->dX = dX;
    seg->fs[0] = f0;
    seg->fs[1] = f1;

    if (Y < gd->thisymin)
        gd->thisymin = Y;
    ymax = (seg->ymax + FRAC - 1) >> FRAC_BITS;
    //  if (ymax >= gd->thisheight)
    //     ymax = gd->thisheight-1;
    if (ymax > gd->thisymax)
        gd->thisymax = ymax;

    segs = gd->thissegs;
    //printf("Y is %ld\n",Y);
    if (segs[Y] == 0) {
        segs[Y] = seg;
    } else {
        Segment *s,*prev;

        prev = 0;
        for(s = segs[Y]; s; prev = s, s = s->next) {
            //printf("s is %p\n",s); printf("seg point is %p\n",seg);printf("Y is %ld\n",Y);
            //printf("Y is %ld\n",Y);
            if (s->X > seg->X) {
                if (prev) {
                    prev->next = seg;
                    seg->next = s;
                } else {
                    seg->next = segs[Y];
                    segs[Y] = seg;
                }
                break;
            }
        }
        if (s == 0) {
            prev->next = seg;
            seg->next = s;
        }
    }
}

Segment *
progressSegments(GraphicDevice *gd1,Segment * curSegs, long y) {
    Segment *seg,*prev;

    // Update current segments
    seg = curSegs;
    prev = 0;
    while(seg) {
        if ((y*FRAC) > seg->ymax) {
            // Remove this segment, no more valid
            if (prev) {
                prev->nextValid = seg->nextValid;
            } else {
                curSegs = seg->nextValid;
            }
            seg = seg->nextValid;
        } else {
            seg->X += seg->dX * FRAC;
            prev = seg;
            seg = seg->nextValid;
        }
    }
    return curSegs;
}


Segment *
newSegments(GraphicDevice *gd,Segment *curSegs, Segment *newSegs) {
    Segment *s,*seg,*prev;

    s = curSegs;
    prev = 0;

    // Check for new segments
    for (seg = newSegs; seg; seg=seg->next) {
        // Place it at the correct position according to X
        if (curSegs == 0) {
            curSegs = seg;
            seg->nextValid = 0;
        } else {
            for(; s; prev = s, s = s->nextValid) {
                if ( s->X > seg->X ||
                        ( (s->X == seg->X) &&
                          ( (seg->x1 == s->x1 && seg->dX < s->dX) ||
                            (seg->x2 == s->x2 && seg->dX > s->dX)
                          ))) {
                    // Insert before s
                    if (prev) {
                        seg->nextValid = s;
                        prev->nextValid = seg;
                    } else {
                        seg->nextValid = curSegs;
                        curSegs = seg;
                    }
                    break;
                }
            }
            // Append at the end
            if (s == 0) {
                prev->nextValid = seg;
                seg->nextValid = 0;
            }
        }

        s = seg;
    }

    return curSegs;
}

#if 0

#endif


void
renderScanLine(GraphicDevice *gd3,long y, Segment *curSegs) { //printf("to renderscanline\n");
    Segment *seg;
    long width;
    int fi = 1;
    FillStyleDef *f;

    width = gd3->targetWidth * FRAC;
    //printf("to 1\n");
    if (curSegs && curSegs->fs[0] && curSegs->fs[1] == 0) {
        fi = 0;//printf("to in 2\n");
    }
    if(curSegs)
        //printf("to 3\n");
        for(seg = curSegs; seg && seg->nextValid; seg = seg->nextValid) {
            // if (seg->nextValid->X <0)
            //   continue;
            //if ((seg->X>>SEGFRAC) > width)
            //   break;

            f = seg->fs[fi];

            if (f) {

                switch (f->FillStyleType) {
                case f_Solid:

                    if (seg->aa) {
                        fillLineAA16(gd3,f, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    } else  {
                        fillLineAA16(gd3,f, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    }
                    break;
                case f_TiledBitmap:
                case f_clippedBitmap:

                    fillLineBitmap(gd3,f, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    break;
                case f_LinearGradient:



                    fillLineLG16(gd3,f->GradientP, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    break;
                case f_RadialGradient:


                    fillLineRG16(gd3,f->GradientP, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    break;
                case f_None:
                    break;
                }
            }
        }
}

void
renderScanLine1(GraphicDevice *gd,long y, Segment *curSegs) { //printf("to renderscanline\n");
    Segment *seg;
    long width;
    int fi = 1;
    FillStyleDef *f;

    width = gd->targetWidth * FRAC;
    //printf("to 1\n");
    if (curSegs && curSegs->fs[0] && curSegs->fs[1] == 0) {
        fi = 0;//printf("to in 2\n");
    }
    if(curSegs)
        //printf("to 3\n");
        for(seg = curSegs; seg && seg->nextValid; seg = seg->nextValid) {
            // if (seg->nextValid->X <0)
            //   continue;
            //if ((seg->X>>SEGFRAC) > width)
            //   break;

            f = seg->fs[fi];

            if (f) {

                switch (f->FillStyleType) {
                case f_Solid:

                    if (seg->aa) {
                        fillLineAA161(gd,f, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    } else  {
                        fillLineAA161(gd,f, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    }
                    break;
                case f_TiledBitmap:
                case f_clippedBitmap:
                    break;
                    fillLineBitmap(gd,f, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    break;
                case f_LinearGradient:

                    break;

                    fillLineLG16(gd,f->GradientP, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    break;
                case f_RadialGradient:
                    break;

                    fillLineRG16(gd,f->GradientP, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                    break;
                case f_None:
                    break;
                }
            }
        }
}




void
drawPolygon(GraphicDevice *gd1) {
    long y;
    Segment *curSegs,*seg;

    if (gd1->thisymax == -8000)
        return;

    // Foreach scanline
    curSegs = 0;

    for(y=gd1->thisymin; y <= gd1->thisymax; y++) {

        // Make X values progess and remove unuseful segments
        curSegs = progressSegments(gd1,curSegs, y);

        // Add the new segment starting at the y position.
        curSegs = newSegments(gd1,curSegs, gd1->thissegs[y]);

        if (gd1->scan_line_func == NULL) {

            renderScanLine(gd1,y, curSegs);
        } else {
            for(seg = curSegs; seg && seg->nextValid; seg = seg->nextValid) {
                if (seg->nextValid->X >= seg->X) {
                    gd1->scan_line_func(gd1->scan_line_func_id, y, seg->X>>SEGFRAC, seg->nextValid->X>>SEGFRAC);
                }
            }
        }
    }

    /* free the segments */
    //printf("gd1->tisymin is %ld  gd->thisymax is %ld\n", gd1->thisymin,gd1->thisymax);
    assert(gd1->thisymax<8000);
    assert(gd1->thisymin >-8000);
    // memset((gd1->thissegs) + gd1->thisymin, 0,
    //       (gd1->thisymax - gd1->thisymin + 1) * sizeof(Segment *));
    memset((gd1->thissegs1),0,(16000) * sizeof(Segment *));

    gd1->thisymax = -8000;
    gd1->thisymin =8000; //gd1->thisheight;
    //printf("init thisymin is %ld\n",gd1->thisymin);
    gd1->seg_pool_cur = gd1->seg_pool;
}

void
drawPolygon1(GraphicDevice *gd1) {
    long y;
    Segment *curSegs,*seg;

    if (gd1->thisymax == -8000)
        return;

    // Foreach scanline
    curSegs = 0;


    for(y=gd1->thisymin; y <= gd1->thisymax; y++) {
        curSegs = progressSegments(gd1,curSegs, y);

        // Add the new segment starting at the y position.
        curSegs = newSegments(gd1,curSegs, gd1->thissegs[y]);
        renderScanLine1(gd1,y, curSegs);
    }
     memset((gd1->thissegs) + gd1->thisymin, 0,
           (gd1->thisymax - gd1->thisymin + 1) * sizeof(Segment *));
    //      
//    memset((gd1->thissegs1),0,(16000) * sizeof(Segment *));

    gd1->thisymax = -8000;
    gd1->thisymin =8000; //gd1->thisheight;
    //printf("init thisymin is %ld\n",gd1->thisymin);
    gd1->seg_pool_cur = gd1->seg_pool;



}

void
updateClippingRegion(GraphicDevice *gd1,Rect *rect) {
    if (!gd1->clipping)
        return;

    transformBoundingBox(&gd1->clip_rect, gd1->adjust, rect, 1);
    gd1->clip_rect.Xmin >>= FRAC_BITS;
    gd1->clip_rect.Xmax >>= FRAC_BITS;
    gd1->clip_rect.Ymin >>= FRAC_BITS;
    gd1->clip_rect.Ymax >>= FRAC_BITS;

    gd1->clip_rect.Xmin-=2;
    gd1->clip_rect.Ymin-=2;
    gd1->clip_rect.Xmax+=2;
    gd1->clip_rect.Ymax+=2;

    if (gd1->clip_rect.Xmin < gd1->viewPort.Xmin)
        gd1->clip_rect.Xmin = gd1->viewPort.Xmin;
    if (gd1->clip_rect.Xmax < gd1->viewPort.Xmin)
        gd1->clip_rect.Xmax = gd1->viewPort.Xmin;
    if (gd1->clip_rect.Ymin < gd1->viewPort.Ymin)
        gd1->clip_rect.Ymin = gd1->viewPort.Ymin;
    if (gd1->clip_rect.Ymax < gd1->viewPort.Ymin)
        gd1->clip_rect.Ymax = gd1->viewPort.Ymin;

    if (gd1->clip_rect.Xmax > gd1->viewPort.Xmax)
        gd1->clip_rect.Xmax = gd1->viewPort.Xmax;
    if (gd1->clip_rect.Ymax > gd1->viewPort.Ymax)
        gd1->clip_rect.Ymax = gd1->viewPort.Ymax;
    if (gd1->clip_rect.Xmin > gd1->viewPort.Xmax)
        gd1->clip_rect.Xmin = gd1->viewPort.Xmax;
    if (gd1->clip_rect.Ymin > gd1->viewPort.Ymax)
        gd1->clip_rect.Ymin = gd1->viewPort.Ymax;
}

void setClipping(GraphicDevice *gd1,int value) {
    gd1->clipping = value;
    if (gd1->clipping == 0) {
        // Reset region
        gd1->clip_rect.Xmin = gd1->viewPort.Xmin;
        gd1->clip_rect.Xmax = gd1->viewPort.Xmax;
        gd1->clip_rect.Ymin = gd1->viewPort.Ymin;
        gd1->clip_rect.Ymax = gd1->viewPort.Ymax;
    }
}
