#ifndef _BITMAP_H_
#define _BITMAP_H_
#include "base_types.h"
#include "swf_file_pub.h"

//  JPEG ļ, character ȫֵ JPEGTables ʹ
struct JPEGTable {
    UI32                Count;
    UI8                 JPEGTables[1];
};

struct  DefineBits      {
    UI8                 CharacterType/* = CharBits*/;
    UI16		CharacterID;
    long		Width;
    long		Height;
    long		Bpl;
    long		Colors;

    unsigned char 	*PixelsP;		// Array of Pixels
    struct RGBA		*ColormapP; 	// Array of color definitions
    unsigned char 	*Alpha_bufP;	// Array of alpha values (no alpha if NULL)

    long		JPEGDataLength;
    UI8                 JPEGData[0];
};

struct DefineBitsJPEG  {
    UI8                 CharacterType /*= CharBitsJPEG*/;
    UI16		CharacterID;
    long		Width;
    long		Height;
    long		Bpl;
    long		Colors;

    unsigned char 	*PixelsP;		// Array of Pixels
    struct RGBA		*ColormapP; 	// Array of color definitions
    unsigned char 	*Alpha_bufP;	// Array of alpha values (no alpha if NULL)

    UI32                JPEGDataLength;
    UI32                AlphaDataLength;
    UI8                 JPEGData[0];
    //  BitmapAlphaData ʼλ JPEGDataLength .
};

// ʹ zip ѹͼƬ.
struct DefineBitsLossless2      {
    UI8                 CharacterType /*= CharBitsLossless*/;
    UI16		CharacterID;
    long		Width;
    long		Height;
    long		Bpl;
    long		Colors;

    unsigned char 	*PixelsP;		// Array of Pixels
    struct RGBA		*ColormapP; 	// Array of color definitions
    unsigned char 	*Alpha_bufP;	// Array of alpha values (no alpha if NULL)

    UI8      		BitmapFormat;
    UI16     		BitmapWidth;
    UI16     		BitmapHeight;
    UI8     		BitmapColorTableSize;
    long    		ZlibBitmapDataLength;
    UI8    		ZlibBitmapData[0];
};

/*
 *  in ָ Bitmap  Character е JPEG  ZIP ѹ
 * ͼƬչλͼ,ٹҵ Character . λͼõڴʵַ
 */
int bmp_makebmp(struct DefineCharacter* InStruct,swf_file_t *swf_p);

#endif
