#ifndef _SWF_FILE_H_
#define _SWF_FILE_H_
#include <inttypes.h>
#include <pthread.h>
#include <glib.h>
#include "base_types.h"
#include "define.h"
#include "player_pub.h"
#include "changed.h"
#include "xwin_event.h"
//#include "render_mask.h"
struct asset {
    struct asset	*next_p;
    char		*name_p;
    UI16		id;
};

struct Dict {
    int 			count;
    struct asset		*assets_p;
    struct DefineCharacter*     dict[1];
};

typedef struct swf_file {
    player_t		*holder_p;
    // swf ļͷ
    UI8			compressed;
    UI8         	version;
    UI32        	file_length;
    struct RECT 	frame_size;
    UI16        	frame_rate;
    UI16        	frame_count;

    // ֵ
    struct Dict 	*dict_p;
    pthread_mutex_t     dict_mutex;

    // ڵ
    GNode		*_root_p;

    // 
    struct spliter	*spliter_p;

    int			handle;

    struct changed	*changed_p;
    struct MaskEntry	*mask_stack_p;

    struct RGB		BackgroundColor;
    struct JPEGTable 	*JPEGTableP;

    UI16		next_ins_name_num;	// һϵͳʵĺ
    STRING		focused_name;		// 뽹Ľڵ.

    GData		*dvar_list_p;		// DTX б
}
swf_file_t;

swf_file_t* swf_new(player_t *player_p);
int swf_sym_to_char_id(swf_file_t *swf_p,char* name_p);		// symbol (asset)  char id
void swf_first_pass(GNode *node_p);
void swf_second_pass(GNode *node_p);
void swf_init_root(swf_file_t *swf_p);
void swf_destory(swf_file_t *self_p);

#endif
