#include <stdio.h>
#include <glib.h>
#include <assert.h>
#include "define.h"
#include "player_pub.h"
#include "base_types.h"
#include "instance.h"
#include "swf_file_pub.h"
#include "spliter_pub.h"
#include "render_pub.h"
#include "movie_clips_ins.h"
#include "movie_clips_def.h"
#include "button_ins.h"
#include "button_def.h"
#include "action.h"
#include "event.h"
#include "action_fortest.h"
#include "xwin_event.h"
#if WITH_DMALLOC
#include <dmalloc.h>
#endif

extern player_t      *player_p;

void ac_exec_do(to_exec_t *to_exec_p) {
    struct 	ActionRecord	*p;
    char	*name_p = to_exec_p->name_p;

    printf("\tname %s\n", name_p);

    // button ¼е鶼Ƕ mc 
    /*
    if (ins_p->ins_type == INS_BTN) {
        node_p = node_p -> parent;
    };
    assert(node_p);
    name_p = ins_node_to_name(node_p);
    */
    p = to_exec_p->as_p;
    while (p) {
        actionscript(p->Code,p->Length,name_p);
        p = p->NextP;
    }
    free(name_p);
    //    if (to_exec_p->as_p)
};

void ac_exec(void) {
    GSList		*p;
    to_exec_t		*to_exec_p;
    //   printf("in ac_exec\n");

    while (player_p->actionq_p) {
        to_exec_p = (to_exec_t*)player_p->actionq_p->data;
        assert(to_exec_p);
        if (to_exec_p->name_p) {
            //   printf("in ac_exec ------------- %p \n", to_exec_p->as_p);
            ac_exec_do(to_exec_p);
        }
        p = player_p->actionq_p;
        player_p->actionq_p = g_slist_remove_link(player_p->actionq_p,p);
        free(p->data);
        g_slist_free_1(p);
    };
};
