#ifndef _PLAYER_PUB_H_
#define _PLAYER_PUB_H_

#include <glib.h>
#include <pthread.h>
#include "xwin_pub.h"
#include "pipe_cmd_pub.h"
#include "pipe_out_pub.h"
#include "sound_mixplay_pub.h"
#include "drag_drop.h"

typedef struct player {
    struct xwin		*xwin_p;
    struct render	*render_p;
    struct pipe_cmd	*pipe_cmd_p;
    struct pipe_out	*pipe_out_p;

    struct swf_file	*_level0_p;
    struct swf_file	*_level1_p;
    struct swf_file	*_level2_p;
    struct swf_file	*_level3_p;
    struct swf_file	*_level4_p;
    struct swf_file	*_level5_p;
    struct swf_file	*_level6_p;
    struct swf_file	*_level7_p;
    struct swf_file	*_level8_p;
    struct swf_file	*_level9_p;
    struct swf_file	*_level10_p;
    struct swf_file	*_level11_p;
    struct swf_file	*_level12_p;
    struct swf_file	*_level13_p;
    struct swf_file	*_level14_p;
    struct swf_file	*_level15_p;

    char	*play_filename_p;
    char	*pipe_cmd_filename_p;
    char	*pipe_out_filename_p;

    GSList		*eventq_p;
    pthread_mutex_t  	eventq_mutex;
    struct drag_obj	drag_obj;

    GSList		*actionq_p;		// ִе ű

    struct pcm_block	pcm_block_head;         // pcm_block ͷ.
    pthread_mutex_t	pcm_block_mutex;        // PCM Ļ

    GSList		*urlq_p;
    pthread_mutex_t  	urlq_mutex;
    pthread_cond_t	urlq_cond;
}
player_t;

player_t * player_new();
void player_arg(player_t *player_p,int argc, char *argv[]);
void player_do_tick(player_t *player_p);
void player_destory(player_t *player_p);
void player_prn_banner(void);
#endif
