#!/bin/sh
fplayer="fplayer"
font="simsun.ttc"
if [ ! -x /usr/bin/perl ];then
 read -p  "Warn!!,The program /usr/bin/perl isn't exist. first, install it,please!"  aaa &&  exit
fi
if [ ! -f ./${fplayer} ] && [ ! -L ./${fplayer} ];then
   if [ -f ../../src/${fplayer} ];then
	rm -rf ./${fplayer} 
        ln -s ../../src/${fplayer} 
   else
	read -p "I must stop , ${fplayer} doesn't exist ,compile it, please" aaa &&  exit
   fi
fi
if [ ! -f ./${font} ] && [ ! -L ./${font} ];then
   if [ -f ../../src/${font} ];then
	rm -rf ./${font} 
        ln -s ../../src/${font} 
   else
	read -p "I must stop , ${font} doesn't exist ,compile it, please" aaa && exit
   fi
fi
chmod 777 fplayer 
chmod u+r simsun.ttc
###############################
total_fail="0"
rm /tmp/blacklist 2>/dev/null
for i in `find ./ -name "*.[s|S][w|W][f|F]"` ;
do
    echo -n "$i			"
    ./fplayer -f $i 2> /dev/null > /dev/null
    result="$?"
    if test "x$result" = "x0" ;
    then
	echo "Pass"
    else
	echo "Fail"
	total_fail=`dc -e "$total_fail 1 + p"`
	echo "$i	$result" >> /tmp/blacklist
    fi;
done;
echo "BlackList"
cat  /tmp/blacklist
echo "TotalFails $total_fail"
